/*#######################################################################################
AVR DCF77 Clock 

Copyright (C) 2005 Ulrich Radig

#######################################################################################*/

#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


#include "uart.h"
#include "clock.h"

#define UART_BAUD_RATE		38400


//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	char buffer[100];
	//Inizialisierung der Seriellen Schnittstelle
	uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU));

	// Test-LED einschalten
	DDRB |= (1<<PB0) | (1<<PB2);
	PORTB |= (1<<PB2);
	
	//PORTB ^= (1<<PB0);
	
	// Internen Pullup fr DCF ausschalten
	DDRD &= ~(1<<PD2);
	PORTD &= ~(1<<PD2);

	// DCF-Flankenwechsel
	_delay_ms(2000);
	DDRD |= (1<<PD3) | (1<<PD4);
	PORTD |= (1<<PD3);  // PON auf High
	_delay_ms(500);
	PORTD &= ~(1<<PD3); // PON auf LOW, DCF77-Modul sollte starten



	//Globale Interrupts einschalten
	sei();

	uart_puts("DCF 77 Clock by Ulrich Radig\n\n");
		
	_delay_ms(500);

	//Starten der DCF77 Uhr
	Start_Clock();
	

	
    
	//Ausgabe der Zeit auf der Seriellen Schnittstelle in einer Endlosschleife
	while (1)
	{
		sprintf(buffer,"%i-%i-%i Time: %i:%i:%i Sync: %i  Rx: %i       \r",
				day,mon,year,hh,mm,ss,flags.dcf_sync,flags.dcf_rx);
	    uart_puts(buffer);
		//Wait a short time
		_delay_ms(500);
		
	}
	
return (1);
}

